---
title: FileReader.readyState
slug: Web/API/FileReader/readyState
tags:
  - API
  - File API
  - Files
  - Property
  - Reference
---
<div>{{APIRef("File API")}}</div>

<p>The {{domxref("FileReader")}} <strong><code>readyState</code></strong> property provides the current state of the reading operation a <code>FileReader</code> is in. A <code>FileReader</code> exists in one of the following states:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Value</th>
   <th scope="col">State</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td><code>0</code></td>
   <td><code>EMPTY</code></td>
   <td>Reader has been created. None of the read methods called yet.</td>
  </tr>
  <tr>
   <td><code>1</code></td>
   <td><code>LOADING</code></td>
   <td>A read method has been called.</td>
  </tr>
  <tr>
   <td><code>2</code></td>
   <td><code>DONE</code></td>
   <td>The operation is complete.</td>
  </tr>
 </thead>
</table>

<dl>
 <dt><code>EMPTY</code></dt>
 <dd>The <code>FileReader</code> has been created, but no readAs method was called yet.</dd>
 <dt><code>LOADING</code></dt>
 <dd>A readAs method was invoked. A {{domxref("File")}} or {{domxref("Blob")}} is being read, and no error has occurred yet.</dd>
 <dt><code>DONE</code></dt>
 <dd>The read operation is complete. This could mean that: the entire {{domxref("File")}} or {{domxref("Blob")}} has been read into memory, a file read error occurred, or {{domxref("FileReader.abort()", "abort()")}} was called and the read was cancelled.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var reader = new FileReader();
console.log('EMPTY', reader.readyState); // readyState will be 0

reader.readAsText(blob);
console.log('LOADING', reader.readyState); // readyState will be 1

reader.onloadend = function () {
  console.log('DONE', reader.readyState); // readyState will be 2
};
</pre>

<h2 id="Value">Value</h2>

<p>A number which is one of the three possible state constants define for the {{domxref("FileReader")}} API.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("File API", "#dom-filereader-readystate", "readyState")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileReader.readyState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Blob")}}</li>
</ul>
